package com.iformall.controller.mem;

import com.github.pagehelper.PageInfo;
import com.iformall.annotation.SystemControllerLog;
import com.iformall.common.ErrorCode;
import com.iformall.common.Result;
import com.iformall.common.ResultData;
import com.iformall.controller.base.BaseController;
import com.iformall.domain.po.WxCUserBasicInfo;
import com.iformall.domain.po.WxScoreHistory;
import com.iformall.enums.EnumCUserBasicInfoStatus;
import com.iformall.service.WxCUserBasicInfoService;
import com.iformall.service.WxScoreHistoryService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("wxScoreHistory")
public class WxScoreHistoryController extends BaseController {
    private final Logger logger = LoggerFactory.getLogger(this.getClass());

    @Autowired
    private WxScoreHistoryService wxScoreHistoryService;

    @Autowired
    private WxCUserBasicInfoService wxCUserBasicInfoService;


    @ApiOperation("分页列表接口")
    @GetMapping("list")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "页数", dataType = "int", paramType = "query", required = true),
            @ApiImplicitParam(name = "pageSize", value = "每页条数", dataType = "int", paramType = "query", required = true)})
    @SystemControllerLog(description = "成长值-历史")
    public ResultData list(@ModelAttribute WxScoreHistory wxScoreHistory, Integer pageNum, Integer pageSize) {
        logger.debug("[" + getIpAddr() + "] WxScoreHistoryController::list");
        if (null == wxScoreHistory) wxScoreHistory = new WxScoreHistory();
        final PageInfo<WxScoreHistory> page = wxScoreHistoryService.listAsPage(wxScoreHistory, pageNum, pageSize);
        return new ResultData(page);
    }

    @ApiOperation("新增接口")
    @PostMapping("add")
    @SystemControllerLog(description = "成长值-新增")
    public ResultData add(@RequestBody WxScoreHistory wxScoreHistory) {
        logger.debug("[" + getIpAddr() + "] WxScoreHistoryController::add");
        //Assert.notNull(wxScoreHistory.getName(), "角色名不能为空");
        //Assert.isTrue(!checkUnique(sysRole.getName(), null), "重复的角色名");
        if (checkMemberStatus(wxScoreHistory.getCUserId())) {
            return new ResultData(ErrorCode.MEMBER_IS_LOCKED);
        }
        wxScoreHistoryService.saveOrUpdate(wxScoreHistory);
        return new ResultData();
    }

    @ApiOperation("根据id更新接口")
    @PostMapping("update")
    @SystemControllerLog(description = "成长值-更新")
    public ResultData update(@RequestBody WxScoreHistory wxScoreHistory) {
        logger.debug("[" + getIpAddr() + "] WxScoreHistoryController::update");
        if (checkMemberStatus(wxScoreHistory.getCUserId())) {
            return new ResultData(ErrorCode.MEMBER_IS_LOCKED);
        }
        wxScoreHistoryService.saveOrUpdate(wxScoreHistory);
        return new ResultData();
    }

    public boolean checkMemberStatus(Long userId) {
        WxCUserBasicInfo wxCUserBasicInfo = wxCUserBasicInfoService.getById(userId);
        if (wxCUserBasicInfo != null && wxCUserBasicInfo.getStatus().equals(EnumCUserBasicInfoStatus.LOCKED.getCode())) {
            logger.info("会员权益被锁定:cUserId:" + userId);
            return true;
        }
        return false;
    }

    @ApiOperation("根据id删除接口")
    @GetMapping("/del")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    @SystemControllerLog(description = "成长值-删除")
    public ResultData delete(Long id) {
        logger.debug("[" + getIpAddr() + "] WxScoreHistoryController::delete");
        wxScoreHistoryService.deleteById(id);
        return new ResultData(Result.SUCCESS, "删除成功", null);
    }

    @ApiOperation("根据id查询接口")
    @GetMapping("/findById")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    @SystemControllerLog(description = "成长值-查询")
    public ResultData findById(Long id) {
        logger.debug("[" + getIpAddr() + "] WxScoreHistoryController::findById");
        return new ResultData(Result.SUCCESS, "查询成功", wxScoreHistoryService.getById(id));
    }


}
